<template>
    <div>
        <form
            v-if="getProduct"
            @submit.prevent="editProduct()"
        >
            <div class="form-group row w-75">
                <label for="name" class="my-form col-sm-2 col-form-label">Назва:</label>
                <div class="col-sm-10">
                    <input type="text"
                           class="form-control"
                           id="name"
                           name="name"
                           v-model="getProduct.name"
                           :class="{'error-border error-text': this.nameErrors.length > 0}"
                    >
                </div>
                <span v-if="nameErrors"
                      :class="{'error-text': this.nameErrors.length > 0}"
                >{{ nameErrors[0] }}</span>
            </div>

            <div class="form-group row w-75">
                <label for="price" class="my-form col-sm-2 col-form-label">Ціна:</label>
                <div class="col-sm-10">
                    <input type="text"
                           class="form-control"
                           id="price"
                           name="price"
                           v-focus v-model="getProduct.price"
                           :class="{'error-border error-text': this.priceErrors.length > 0}"
                    >
                </div>
                <span v-if="priceErrors"
                      :class="{'error-text': this.priceErrors.length > 0}"
                >{{ priceErrors[0] }}</span>
            </div>

            <div class="form-group row w-75">
                <label for="size" class="my-form col-sm-2 col-form-label">Розміри:</label>
                <div class="col-sm-10">
                    <input type="text"
                           class="form-control"
                           id="size"
                           name="size"
                           v-model="getProduct.size"
                           :class="{'error-border error-text': this.sizeErrors.length > 0}"
                    >
                </div>
                <span v-if="sizeErrors"
                      :class="{'error-text': this.sizeErrors.length > 0}"
                >{{ sizeErrors[0] }}</span>
            </div>

            <div class="form-group row w-75">
                <label for="photo" class="my-form col-sm-2 col-form-label">Фото:</label>
                <div class="col-sm-10">
                    <input type="text"
                           class="form-control"
                           id="photo"
                           name="photo"
                           v-model="getProduct.photo"
                           :class="{'error-border error-text': this.photoErrors.length > 0}"
                    >
                </div>
                <span v-if="photoErrors"
                      :class="{'error-text': this.photoErrors.length > 0}"
                >{{ photoErrors[0] }}</span>
            </div>

            <div class="form-group row w-75">
                <label for="description" class="my-form col-sm-2 col-form-label">Опис:</label>
                <div class="col-sm-10">
                    <input type="text"
                           class="form-control"
                           id="description"
                           name="description"
                           v-model="getProduct.description"
                           :class="{'error-border error-text': this.descriptionErrors.length > 0}"
                    >
                </div>
                <span v-if="descriptionErrors"
                      :class="{'error-text': this.descriptionErrors.length > 0}"
                >{{ descriptionErrors[0] }}</span>
            </div>

            <input type="submit"
                   value="Далі"
                   class="btn btn-block btn-light float-sm-right"
                   :disabled="this.nameErrors.length > 0 ||
                              this.priceErrors.length > 0 ||
                              this.sizeErrors.length > 0 ||
                              this.photoErrors.length > 0 ||
                              this.descriptionErrors.length > 0"
            />

        </form>
    </div>

</template>

<script>
import {mapActions} from "vuex";
import productValidationMixin from "@/mixins/productValidationMixin.js";

export default {
    name: "EditProduct",
    mixins: [productValidationMixin],
    props: {
        product: {
            type: Object,
            default: () => ({}),
        }
    },
    computed: {
        id() {
            return this.$route.params.id;
        },
        getProduct() {
            return this.$store.getters.getProduct(this.id);
        },
    },

    methods: {
        ...mapActions(["updateProduct"]),
        editProduct(){
            this.updateProduct(this.getProduct);
            this.$router.push({ name: 'products' });
        },
    },

    created() {

    },
}
</script>

<style lang="scss" scoped>
.my-form{
    margin-top: 10px;
}

.error {
    &-border {
        border: 1px solid red;
    }
    &-text {
        color: red;
    }
}

.disabled-button {
    disabled: "disabled";
}
</style>
